package higa.jhcl.model;

import java.io.Serializable;

import higa.util.EventMulticaster;

public class BasicSingletonContainer
  implements SingletonModel, Serializable {

  private Object item;
  private EventMulticaster modelCaster =
    new EventMulticaster();

  private boolean eventEnabled = true;

  public BasicSingletonContainer() {}

  public BasicSingletonContainer(Object item) {
    this.item = item;
  }

  public Object get() {
    Object copy = new Object();
    copy = item;
    return copy;
  }

  public void addModelListener(SingletonModelListener listener) {
    modelCaster.add(listener);
  }

  public void removeModelListener(SingletonModelListener listener) {
    modelCaster.remove(listener);
  }

  public boolean canSet() {
    return true;
  }

  public void set(Object item) {
    this.item = item;

    processModelEvent(new SingletonModelEvent(
      this, ModelEvent.CONTENT_CHANGED));
  }

  public void setEventEnabled(boolean enabled) {
    eventEnabled = enabled;
  }

  protected void processModelEvent(
    SingletonModelEvent e) {

    if (eventEnabled && modelCaster.hasListeners()) {
      modelCaster.dispatch(e);
    }
  }
}