package higa.sql.dataset;

import java.util.EventListener;

import higa.util.BasicEvent;
import higa.util.Dispatch;

public class DataChangeEvent
  extends BasicEvent implements Dispatch {

  public final static int DATA_CHANGED = 0;

  private int status = Status.NORMAL;

  public DataChangeEvent(Object source, int id, int newStatus) {

    super(source, id);
    status = newStatus;
  }

  public int getStatus() {
    return status;
  }

  public void dispatch(
    EventListener listener) {

    DataChangeListener dcl =
      (DataChangeListener)listener;

    switch (getID()) {
      case DATA_CHANGED:
        dcl.dataChanged(this);
        break;
      default:
        throw new IllegalStateException(
          "ID:" + getID());
    }
  }
}