package higa.sql.dataset;

import java.io.Serializable;

import java.util.Hashtable;
import java.util.Enumeration;

public class LogEntry implements Serializable {

  private int rowIndex;
  private int status = Status.NORMAL;
  private ReadRow oldRow;
  private Hashtable columnValues =
    new Hashtable();

  public LogEntry() {}

  public LogEntry(int rowIndex, int status) {
    this.rowIndex = rowIndex;
    this.status = status;
  }

  public LogEntry(int rowIndex, int status,
    ReadRow oldRow) {

    this(rowIndex, status);
    this.oldRow = oldRow;
  }

  public void setRowIndex(int rowIndex) {
    this.rowIndex = rowIndex;
  }

  public int getRowIndex() {
    return rowIndex;
  }

  public void setStatus(int status) {
    this.status = status;
  }

  public int getStatus() {
    return status;
  }

  public void setOldRow(ReadRow rr) {
    oldRow = rr;
  }

  public ReadRow getOldRow() {
    return oldRow;
  }

  public void setColumnValue(int index, Object value) {
    ColumnValue cv = new ColumnValue(index, value);

    columnValues.put(
      new Integer(index), cv);
  }

  public ColumnValue[] getColumnValues() {
    if (columnValues.isEmpty()) {
      return new ColumnValue[0];
    }

    int count = columnValues.size();
    ColumnValue[] cvs =
      new ColumnValue[count];

    Enumeration elements =
      columnValues.elements();

    for (int i = count - 1; i >= 0; i--) {
      cvs[i] = (ColumnValue)elements.nextElement();
    }

    return cvs;
  }

  public String toString() {
    StringBuffer sb = new StringBuffer();
    sb.append("rowIndex:" + rowIndex + "\n");
    sb.append("oldRow:" + oldRow);
    if (sb.charAt(sb.length() - 1) != '\n') {
      sb.append("\n");
    }

    sb.append("status:" +
      Status.getStatusName(status) + "\n");

    ColumnValue[] cvs = getColumnValues();
    int count = cvs.length;
    StringBuffer sb2 = new StringBuffer();

    for (int i = 0; i < count; i++) {
      sb2.insert(0, cvs[i] + "\t");
    }

    if (sb2.length() > 0) {
      sb2.setCharAt(sb2.length() - 1, '\n');
      sb.append(sb2);
    }

    return sb.toString();
  }
}