package higa.jhcl.model;

import java.util.Vector;

import higa.util.EventMulticaster;

public abstract class BasicSelection {

  private Vector array = new Vector();

  public int getCount() {
    return array.size();
  }

  protected Object doGet(int index) {
    return array.elementAt(index);
  }

  protected boolean contains(Object location) {
    return array.contains(location);
  }

  protected synchronized boolean doAdd(Object location) {
    if (!array.contains(location)) {
      array.addElement(location);
      return true;
    }

    return false;
  }

  protected synchronized boolean doRemove(Object location) {
    return array.removeElement(location);
  }

  protected synchronized boolean doRemoveAll() {
    if (array.size() > 0) {
      array.removeAllElements();
      return true;
    }

    return false;
  }

  public final String toString() {
    String cn = getClass().getName();
    return cn.substring(cn.lastIndexOf('.')+1) +
      "[" + paramString() + "]";
  }

  protected String paramString() {
    return "size=" + array.size() +
      "\narray=" + array;
  }
}